package org.gcube.common.authorization.client.proxy;

import java.util.List;

import org.gcube.common.authorization.client.exceptions.ObjectNotFound;
import org.gcube.common.authorization.library.AuthorizationEntry;
import org.gcube.common.authorization.library.enpoints.AuthorizationEndpoint;
import org.gcube.common.authorization.library.policies.Policy;
import org.gcube.common.authorization.library.provider.ClientInfo;

public interface AuthorizationProxy {

	AuthorizationEndpoint getEndpoint();
	
	void setEndpoint(AuthorizationEndpoint endpoint);
		
	AuthorizationEntry get(String token) throws ObjectNotFound, Exception;

	String generateToken(ClientInfo client, String context)
			throws Exception;
	
	void addPolicies(List<Policy> policies) throws Exception;

	void removePolicies(long ... ids) throws Exception;
	
	List<Policy> getPolicies(String context) throws Exception;
}
