package org.gcube.common.authorizationservice.cl;

import static org.gcube.common.authorization.client.Constants.authorizationService;

import java.util.ArrayList;
import java.util.List;

import org.gcube.common.authorization.client.exceptions.ObjectNotFound;
import org.gcube.common.authorization.library.policies.Policy;
import org.gcube.common.authorization.library.policies.ServiceAccess;
import org.gcube.common.authorization.library.policies.User;
import org.gcube.common.authorization.library.policies.User2ServicePolicy;
import org.gcube.common.authorization.library.provider.UserInfo;
import org.junit.Test;
public class CallTest {

	
	@Test
	public void call()  throws Exception{
		try{
			System.out.println(authorizationService().get("f676d94d-af4c-4805-9225-98620f2e1aa0"));
		}catch(ObjectNotFound onf){
			onf.printStackTrace();
		}
	}
	
	@Test
	public void requestToken()  throws Exception {
		
		//ScopeProvider.instance.set("/gcube/devsec");
		String token = authorizationService().generateToken(new UserInfo("lucio.lelii", new ArrayList<String>()), "/gcube/devsec");
		System.out.println("token is: "+token);
		
	}
		
	@Test
	public void addPolicy()  throws Exception {
		List<Policy> policies = new ArrayList<Policy>();
		policies.add(new User2ServicePolicy("/gcube/devsec", new ServiceAccess(), new User("lucio.lelii") ));
		authorizationService().addPolicies(policies);
	}
	
	@Test
	public void getPolicies()  throws Exception{
		List<Policy> policies = authorizationService().getPolicies("/gcube/devsec");
		System.out.println(policies);	
	}
	
	@Test
	public void removePolicy()  throws Exception {
		authorizationService().removePolicies(3);
	}
}
